﻿/* ETBtest.jsx ------ UTF-8 -----------------------------------------------------------------------
                 Simple sample script for ETB
   Documentation www.daube.ch/docu/fmaker73.html
   Comment       To be placed in Startup folder of user area
   Reference     Based on SaveBookAsOldVersion 2013-09-04 by Carmen Publishing Inc. (www.frameexpert.com)
                 Traduction française avec l'aide de Babylon et Deepl par Klaus Daube
   Attention     Code must be UTF-8. With Windows cp no umlauts etc. are allowed in menu items.
   Copyleft      2017 Klaus Daube, Zürich, Switzerland, klaus@daube.ch
   History       2017-006-30 v1.0 released:
                 2018-01-16 v 1.1 New command name
*/ ; // ===========================================================================================
#target framemaker  

var gsETBtest_title = { en: "Testing a jsx script in %apdata%\...\FrameMaker\vv\Startup [ETB]",
                        de: "Test eines jsx scripts in %apdata%\...\FrameMaker\vv\Startup[ETB]",
                        fr: "Test d'un script jsx dans  %apdata%\...\FrameMaker\vv\Startup [ETB]"
                      };
var gsETBtest_msg   = { en: "Befor You test your own script, rename this script to ETBtest-ori.jsx"
                          + "\n• Name Your script ETBtest.jsx"
                          + "\n• You can now invoke it from the ETB tool-bar Extra (last icon)."
                          + "\n\nAfter your tests please rename ETBtest-ori.jsx back to ETBtest.jsx",
                        de: "Vor dem test Ihres scripts bitte dieses script auf ETBtest-ori.jsx umbenennen"
                          + "\n• Benennen Sie ihr script ETBtest.jsx"
                          + "\n• Nun kann ihr script von der ETB tool-bar Extra (letztes icon) aufgerufen werden."
                          + "\n\nNach den tests bitte ETBtest-ori.jsx zurück benennen auf ETBtest.jsx",
                        fr: "Avant de tester votre propre script, renommez ce script pour ETBtest-ori.jsx"
                          + "\n• Votre script nom ETBtest.jsx"
                          + "\n• Vous pouvez maintenant invoquer de l'ETB tool-bar Extra (dernière icône). "
                          + "\n\nAprès vos tests renommez ce ETBtest-ori.jsx retour à ETBtest.jsx"
                      };
var gsETBtest_NoDoc = { en: "No book or document active",
                        de: "Kein buch oder dokument aktiv",
                        fr: "Pas de livre ou document est actif"
                      };

SwitchUILanguage ();
//SetupNotifications ();                          // Not required for this simple test script
SetUpMenu();                                      // out-comment for debugging


function SetUpMenu() { // =========================================================================
// This function MUST NOT be named DefineMenu - because this is a reserved function!
// Errors in ESTK: Menu position can not be changed - see bug report FRMAKER-2752
// No menu is defined here - it is set up in customui.cfg / menus.cfg
  var cmdDoc = DefineCommand (1, "ETB_test", "Test a script [ETB]", ""); 
  UpdateMenus();
} // --- end SetUpMenu

function Command(cmd) { // ========================================================================
	switch(cmd)  {	                                // Respond to menu command.
		case 1: 
      WhatIsToDo();
      break;
    }
} // --- end Command

function WhatIsToDo () { // === This is what the test script will do ==============================
  alert (localize(gsETBtest_msg), localize(gsETBtest_title));
  return;
}

function SetupNotifications () { // Watch for the following notifications ========================= 
  Notification (Constants.FA_Note_PostActiveDocChange, true);  
} // --- end SetupNotifications

function Notify (note, object, sparam, iparam) {  // Handle triggered events ======================
  if (typeof  object == "undefined") {return;}    // just started in StartUp folder
  switch (note) {
    case Constants.FA_Note_PostActiveDocChange:   // active document has changed
      if (!app.ActiveDoc.ObjectValid() && !app.ActiveBook.ObjectValid()) {
        alert ("ETBtest: " + localize (gsETBtest_NoDoc));
//      wDlg.close();
        return;
      } else {
        if (app.ActiveDoc.ObjectValid()){
//        goActiveDoc = object;
        } else {
//        goActiveBook = object;
        }
      }
    break;
    
    default:	                                    // unknown notification
  }
} // --- end Notify

function SwitchUILanguage () {; // === Switch language according to application language ==========
  switch (app.Language) {
    case Constants.FV_LANG_BRITISH:
    case Constants.FV_LANG_ENGLISH: {
      $.locale = "en"; break; 
    }
    case Constants.FV_LANG_CANADIAN_FRENCH: 
    case Constants.FV_LANG_FRENCH: {
      $.locale = "fr"; break; 
    }
    case Constants.FV_LANG_GERMAN: 
    case Constants.FV_LANG_NEW_GERMAN: 
    case Constants.FV_LANG_NEW_SWISS_GERMAN:	
    case Constants.FV_LANG_SWISS_GERMAN:	{
      $.locale = "de"; break; 
    }
    default: {
      $.locale = "en"; break; 
    }
  }
} // --- end SwitchUILanguage
